{--------------------------------------------------------}
{                                                        }
{    Radio50 - Executor interativo de streams de udio   }
{                                                        }
{    Busca uma rdio pelo nome                           }
{                                                        }
{    Autor:  Jos Antonio Borges                         }
{                                                        }
{    Em outubro/2015                                     }
{                                                        }
{--------------------------------------------------------}

unit rdBusca;

interface
uses
    dvcrt,
    dvwin,
    dvForm,
    dvAmplia,
    sysUtils,
    classes,
    rdmsg,
    rdvars,
    rdbass,
    rdFFPlay;

procedure buscaRadioPeloNome;

implementation

{--------------------------------------------------------}
{         busca uma rdio por parte do nome
{--------------------------------------------------------}

procedure buscaRadioPeloNome;
var nomeBusca: string;
    s, so: string;
    slOrig, slBusca: TStringList;
    n, i, p: integer;
    nomeRadio, url, categoria: string;
    c1, c2: char;
    sel: boolean;
begin
    repeat
        mensagem ('RDNOMBUS', 1);  {'Informe parte do nome a buscar (mnimo 3 letras): '}
        sintReadln (nomeBusca);
        if nomeBusca = '' then
            begin
                mensagem ('RDDESIST', 1);  {'Desistiu'}
                exit;
            end;

        if length(nomeBusca) < 3 then
            mensagem ('RDNOMINV', 2);    {'Nome invlido'}
    until  length(nomeBusca) >= 3;

    nomeBusca := lowerCase(semAcentos(nomeBusca));

    slOrig := TStringList.Create;
    slOrig.LoadFromFile(arqIndice);
    slBusca := TStringList.Create;

    categoria := '';
    for i := 0 to slOrig.Count-1 do
        begin
             if slOrig[i] = '' then continue;
             s := slOrig[i];
             if s[1] = '[' then
                 categoria := copy (s, 2, length(s)-2)
             else
                 begin
                     p := pos ('=', s);   // evita erros
                     if p = 0 then continue;
                     nomeRadio := copy (s, 1, p-1);
                     if pos (nomeBusca, lowerCase(semAcentos(nomeRadio))) <> 0 then
                         slBusca.add (intToStr(i)+'['+categoria+']'+s);
                 end;
        end;

    if slBusca.Count = 0 then
        begin
            mensagem ('RDNADAPA', 2);   {'No encontrei nada parecido'}
            delay (1000);
            slOrig.Free;
            slBusca.Free;
            exit;
        end;

    folheiaCria(1, wherey, 79, 24-amplFator);
    for i := 0 to slBusca.count-1 do
        begin
            s := slBusca[i];
            delete (s, 1, pos('[', s));
            categoria := copy (s, 1, pos(']', s)-1);
            nomeRadio := copy (s, 2+length(categoria), 999);
            delete (nomeRadio, pos('=', nomeRadio), 999);
            folheiaAdiciona (nomeRadio + ' em ' + categoria);
        end;

    n := 1;
    repeat
        folheiaExecuta(n, n, c1, c2, true);
    until (c1 = ESC) or (c1 = ENTER);
    folheiaObtemItem(n, nomeRadio, sel);
    folheiaDestroi;

    if c1 = ESC then n := 0;

    if n > 0 then
        begin
            s := slBusca[n-1];
            i := strToInt(copy (s, 1, pos('[',s)-1));
            so := slOrig[i];
            url := copy (so, pos('=', so)+1, 999);
        end;

    slOrig.Free;
    slBusca.Free;

    if n <= 0 then
        begin
            limpaBaixo(4);
            mensagem ('RDDESIST', 1);   {'Desistiu'}
            exit;
        end;

    clrscr;
    textBackground (BLUE);
    writeln (nomeRadio);
    textBackground (BLACK);

    ultimaTocada := url;
    if pos ('FFMPEG ', uppercase(url)) <> 1 then
        tocaRadioBass (url)
    else
        tocaRadioExterna (copy (url, 8, 999));
end;

end.
