{--------------------------------------------------------}
{                                                        }
{    Radio50 - Executor interativo de streams de udio   }
{                                                        }
{    Processamento de opes                             }
{                                                        }
{    Autor:  Jos Antonio Borges                         }
{                                                        }
{    Em outubro/2015                                     }
{                                                        }
{--------------------------------------------------------}

unit rdproces;

interface
uses
    windows,
    dvcrt,
    dvwin,
    dvForm,
    dvSapi,
    dvSapGlb,
    dvAmplia,
    dvInet,
    sysUtils,
    rdprefer,
    rdatuIni,
    rdbass,
    rdffplay,
    rdBusca,
    rdmsg,
    rdvars,
    classes;

procedure processa;
function escolheCategoria: string;

implementation

{--------------------------------------------------------}
{                        ajuda
{--------------------------------------------------------}

procedure ajudaOpcao;
begin
    writeln;
    mensagem ('RDOPCAO', 1);  {'As opes so:'}
    mensagem ('RDOPC_P', 1);  {'P - radios preferidas'}
    mensagem ('RDOPC_F', 1);  {'F - folheia as rdios'}
    mensagem ('RDOPC_E', 1);  {'E - editar uma categoria'}
    mensagem ('RDOPC_I', 1);  {'I - incluir item em uma categoria'}
    mensagem ('RDOPC_R', 1);  {'R - remover item de uma categoria'}
    mensagem ('RDOPC_C', 1);  {'C - criar nova categoria'}
    mensagem ('RDOPC_D', 1);  {'D - destruir uma categoria'}
    mensagem ('RDOPC_A', 1);  {'A - atualizar a lista de rdios por arquivo ATU'}
    mensagem ('RDOPC_T', 1);  {'T - testar um endereo de rdio'}
    mensagem ('RDOPC_B', 1);  {'B - buscar uma rdio pelo nome'}
    mensagem ('RD_ESC' , 1);  {'ESC - terminar'}

    while keypressed do readkey;
    sintBip;
end;

{--------------------------------------------------------}
{            seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasOpcao: char;

    procedure MenuAdiciona (msg: string);
    begin
         popupMenuAdiciona (msg, pegaTextoMensagem (msg));
    end;

var n: integer;
const
    tabLetrasOpcao: string = 'PFEIRCDATB' + ESC;

begin
    garanteEspacoTela (9);
    popupMenuCria (wherex, wherey, 50, length(tabLetrasOpcao), MAGENTA);
    menuAdiciona ('RDOPC_P');  {'P - radios preferidas'}
    menuAdiciona ('RDOPC_F');  {'F - folheia as rdios'}
    menuAdiciona ('RDOPC_E');  {'E - editar uma categoria'}
    menuAdiciona ('RDOPC_I');  {'I - incluir item em uma categoria'}
    menuAdiciona ('RDOPC_R');  {'R - remover item de uma categoria'}
    menuAdiciona ('RDOPC_C');  {'C - criar nova categoria'}
    menuAdiciona ('RDOPC_D');  {'D - destruir uma categoria'}
    menuAdiciona ('RDOPC_A');  {'A - atualizar a lista de rdios por arquivo ATU'}
    menuAdiciona ('RDOPC_T');  {'T - testar um endereo de rdio'}
    menuAdiciona ('RDOPC_B');  {'B - buscar uma rdio pelo nome'}
    menuAdiciona ('RD_ESC' );  {'ESC - terminar'}
    n := popupMenuSeleciona;
    if n > 0 then
        begin
            selSetasOpcao := tabLetrasOpcao[n];
            writeln (tabLetrasOpcao[n]);
        end
    else
        selSetasOpcao := ESC;
end;

{--------------------------------------------------------}
{          folheia as rdios de certa categoria
{--------------------------------------------------------}

function veSeApaga (categoria, nomeRadio: string): boolean;
var c: char;
begin
    mensagem ('RDCNFRMI', 0);    {'Confirma remoo do item '}
    sintWrite (nomeRadio);
    write ('? ');
    c := popupMenuPorLetra('SN');
    writeln;
    result := upcase(c) = 'S';
end;

{--------------------------------------------------------}
{          folheia as rdios de certa categoria
{--------------------------------------------------------}

procedure folheiaRadios (categoria: string);
var
    radios: array [0..128000] of char;
    p: pchar;
    i, n: integer;
    c1, c2: char;
    nomeRadio, url: string;
    sl: TStringList;
    ok: boolean;
begin
    getprivateProfileString (pchar(categoria), NIL, '', radios, 128000, pchar(arqIndice));

    p := radios;
    sl := TStringList.Create;
    while p^ <> #$0 do
        begin
            sl.add (pchar(p));
            p := p + strlen(p) + 1;
        end;
    sl.Sort;
    n := 0;

    repeat
        clrscr;
        textBackground (BLUE);
        sintWriteln (categoria);
        textBackground (BLACK);
        writeln;

        textBackground (RED);
        mensagem ('RDSELRAD', 1);  {'Selecione com as setas a rdio e tecle Enter'}
        textBackground (BLACK);

        folheiaCria(1, wherey, 50, 24-amplFator);
        for i := 0 to sl.Count-1 do
            folheiaAdiciona (sl[i]);
        repeat
            folheiaExecuta(n, n, c1, c2, true);
            if (c1 <> #0) and (c1 <> ESC) and (c1 <> ENTER) then
                repeat
                    n := n + 1;
                until (n > sl.count) or (copy (semAcentos(maiuscAnsi(sl[n-1])), 1, 1) = upcase(c1));
                if n > sl.count then sintbip;
        until (c1 = ESC) or (c1 = ENTER);
        folheiaDestroi;

        if c1 = ESC then break;

        nomeRadio := sl[n-1];
        url := sintAmbienteArq (categoria, nomeRadio, '', arqIndice);
        if url = '' then continue;

        limpabaixo (3);
        textBackground (RED);
        writeln (nomeRadio);
        textBackground (BLACK);
        writeln (url);
        writeln;

        ultimaTocada := url;
        if copy (url, 1, 7) <> 'FFMPEG ' then
            ok := tocaRadioBass (url) >= 0
        else
            ok := tocaRadioExterna (trim (copy (url, 8, 999))) >= 0;

        if not ok then
            if veSeApaga (categoria, nomeRadio) then
                begin
                    sintRemoveAmbienteArq (categoria, nomeRadio, arqIndice);
                    sl.Delete(n-1);
                    mensagem ('RDOKRM', 2);        {'Ok, removido'}
                end;

    until c1 = ESC;

    limpabaixo (3);
    mensagem ('RDFIMFOL', 2);   {'Fim do Folheamento'}
    sl.Free;
end;

{--------------------------------------------------------}
{          Escolhe uma categoria para processar
{--------------------------------------------------------}

function escolheCategoria: string;
var
    categorias: array [0..128000] of char;
    p: pchar;
    n: integer;
begin
    result := '';
    textBackground (RED);
    mensagem ('RDSELCAT', 1);  {'Selecione com as setas a categoria'}
    textBackground (BLACK);

    getprivateProfileString (NIL, NIL, '', categorias, 128000, pchar(arqIndice));
    p := categorias;
    while p^ <> #$0 do
        p := p + strlen(p) + 1;

    p := categorias;
    popupMenuCria (1, wherey, 80, 26-wherey-amplFator, BLACK);   ////////////////////////////// popupmenu com ampliao
    while p^ <> #$0 do
        begin
            if upperCase(strPas(p)) <> 'PREFERIDAS' then
            popupMenuAdiciona ('', strPas(p));
            p := p + strlen(p) + 1;
        end;

    popupMenuOrdena;
    n := popupMenuSeleciona;
    if n <= 0 then exit;

    result := opcoesItemSelecionado;
end;

{--------------------------------------------------------}
{                edita uma categoria
{--------------------------------------------------------}

procedure editaCategoria (nomeCategoria: string);
var
    itens: array [0..128000] of char;
    p: pchar;
    n: integer;
    umaRadio, infoRadio: string;

begin
    repeat
        gotoxy (1, 5);
        mensagem ('RDITEMED', 1);      {'Escolha com as setas o item a editar'}

        p := itens;
        getPrivateProfileString (pchar(nomeCategoria), NIL, '', itens, 128000, pchar(arqIndice));
        while p^ <> #$0 do
            p := p + strlen(p) + 1;

        p := itens;
        popupMenuCria (1, wherey, 80, 26-wherey-amplFator, MAGENTA);
        while p^ <> #$0 do
            begin
                popupMenuAdiciona ('', strPas(p));
                p := p + strlen(p) + 1;
            end;

        popupMenuOrdena;
        n := popupMenuSeleciona;
        if n <= 0 then exit;

        umaRadio := opcoesItemSelecionado;
        writeln (umaRadio);

        writeln;
        limpaBaixo (wherey);
        textBackground (RED);
        mensagem ('RDEDENDR', 1);     {'Editore o endereo de acesso da rdio: '}
        textBackground (BLACK);

        infoRadio := sintAmbienteArq (nomeCategoria, umaRadio, '', arqIndice);
        if sintEditaCampo (infoRadio, wherex, wherey, 255, 80, true) = ENTER then
            begin
                sintGravaAmbienteArq (nomeCategoria, umaRadio, infoRadio, arqIndice);
                writeln;
                mensagem ('RDOK', 1);
            end
        else
            begin
                clreol;
                mensagem ('RDDESIST', 1);  {'Desistiu'}
            end;

        writeln;
    until false;
end;

{--------------------------------------------------------}
{                inclui um item
{--------------------------------------------------------}

procedure incluiItem (nomeCategoria: string);
var item, conteudo: string;

begin
    repeat
        mensagem ('RDITEMIN', 1);   {'Nome do item a incluir'}
        sintReadln (item);
        if item = '' then exit;

        mensagem ('RDITEMCT', 1);   {'Informe o contedo deste item'}
        sintReadln (conteudo);

        sintGravaAmbienteArq (nomeCategoria, item, conteudo, arqIndice);
        mensagem ('RDOK', 2);        {'Ok'}
    until false;
end;

{--------------------------------------------------------}
{                    remove um item
{--------------------------------------------------------}

procedure removeItem (nomeCategoria: string);
var
    itens: array [0..128000] of char;
    p: pchar;
    i: integer;
    c: char;
    n: integer;

begin
    repeat
        gotoxy (1, 5);
        limpaBaixo (wherey);
        mensagem ('RDITEMRM', 1);      {'Escolha com as setas o item a remover'}

        p := itens;
        getPrivateProfileString (pchar(nomeCategoria), NIL, '', itens, 128000, pchar(arqIndice));
        while p^ <> #$0 do
            p := p + strlen(p) + 1;

        p := itens;
        popupMenuCria (1, wherey, 80, 26-wherey-amplFator, MAGENTA);
        while p^ <> #$0 do
            begin
                popupMenuAdiciona ('', strPas(p));
                p := p + strlen(p) + 1;
            end;

        n := popupMenuSeleciona;
        if n <= 0 then exit;

        p := itens;
        for i := 2 to n do
            p := p + strlen(p) + 1;

        mensagem ('RDCNFRMI', 0);    {'Confirma remoo do item '}
        sintWrite (strPas (p));
        write ('? ');
        c := popupMenuPorLetra('SN');
        writeln;
        if upcase(c) = 'S' then
            begin
                sintRemoveAmbienteArq (nomeCategoria, p, arqIndice);
                mensagem ('RDOKRM', 2);        {'Ok, removido'}
            end;

    until false;
end;

{--------------------------------------------------------}
{                cria uma nova categoria
{--------------------------------------------------------}

procedure criaNovaCategoria;
var novaCategoria: string;
const lixo = 'xyxyxyxyxyxyxyxyxy';
begin
    mensagem ('RDNOVSEC', 1);      {'Informe o nome da nova categoria:'}
    sintReadln (novaCategoria);
    if novaCategoria = '' then exit;

    sintGravaAmbienteArq (novaCategoria, lixo, lixo, arqIndice);
    sintRemoveAmbienteArq (novaCategoria, lixo, arqIndice);

    mensagem ('RDOK', 2);        {'Ok'}
end;

{--------------------------------------------------------}
{                destri uma categoria
{--------------------------------------------------------}

procedure destroiUmaCategoria;
var categDestruir: string;
    c, c2: char;
begin
    mensagem ('RDCATDST', 1);      {'Informe o nome da categoria a destruir:'}
    sintReadln (categDestruir);
    if categDestruir = '' then exit;

    mensagem ('RDPERIGO', 1);      {'Destruirei a categoria com este nome, perdendo todas as rdios.'}
    mensagem ('RDAPTD', 0);        {'Aperte D para destruir sem chance de voltar. '}
    sintLeTecla (c, c2);
    writeln;
    if upcase(c) <> 'D' then
        begin
            mensagem ('RDDESIST', 2);  {'Desistiu'}
            exit;
        end;

    sintRemoveAmbienteArq (categDestruir, '', arqIndice);

    mensagem ('RDOK', 2);        {'Ok'}
end;

{--------------------------------------------------------}
{                loop de processamento                   }
{--------------------------------------------------------}

procedure testaRadioPelaURL;
var url: string;
    c: char;
begin
    mensagem ('RDDIGURL', 1);   {'Digite a URL da rdio:'}
    sintReadln (url);
    if url = '' then
        begin
            mensagem ('RDDESIST', 1);   {'Desistiu'}
            exit;
        end;

    mensagem ('RDTOCEXT', 0);   {'Precisa usar um tocador externo? '}
    c := popupMenuPorLetra('SN');
    if c = ESC then
        begin
            mensagem ('RDDESIST', 1);   {'Desistiu'}
            exit;
        end;

    ultimaTocada := url;
    if c <> 'S' then
        tocaRadioBass (url)
    else
        tocaRadioExterna (url);
end;

{--------------------------------------------------------}
{                loop de processamento                   }
{--------------------------------------------------------}

procedure processa;
var c, c2: char;
    nomeCategoria: string;
    opcao: string;
label fim;

begin
    while true do
        begin
            cabecalho (false);
            textBackground (BLUE);
            mensagem ('RDOQUE', 0);      {'Rdio50 - que deseja? '}
            textBackground (BLACK);
            sintLeTecla (c, c2);
            opcao := '';

            if (c = #0) and ((c2 = CIMA) or (c2 = BAIX) or (c2 = F9)) then
                  begin
                      c := selSetasOpcao;
                      if c <> #$1b then
                          opcao := copy (
                             opcoesItemSelecionado, pos ('-', opcoesItemSelecionado)-1, 999);
                  end;

            if c = #$1b then
                begin
                    writeln;
                    goto fim;
                end;

            if (c = #0) and (c2 = F1) then
                 ajudaOpcao
            else
                 begin
                     clrscr;
                     textBackground (BLUE);
                     writeln ('Radio50' + opcao);
                     textBackground (BLACK);
                     writeln;

                     if upcase (c) in ['F', 'E', 'I', 'R'] then
                         begin
                             nomeCategoria := escolheCategoria;
                             if nomeCategoria = '' then continue;
                         end;

                     case upcase(c) of
                         'P': radiosPreferidas;
                         'F': folheiaRadios (nomeCategoria);
                         'E': editaCategoria (nomeCategoria);
                         'I': incluiItem (nomeCategoria);
                         'R': removeItem (nomeCategoria);
                         'C': criaNovaCategoria;
                         'D': destroiUmaCategoria;
                         'A': atualizarIni;
                         'T': testaRadioPelaURL;
                         'B': buscaRadioPeloNome;
                     else
                         mensagem ('RDOPINV', 1); {'Opo invlida'}
                     end;
                 end;
        end;
fim:
    writeln;
end;

end.

